# Markdown Copy for Vim

## Introduction

A simple plugin to allow copying of buffers formatted as markdown to the
clipboard as formatted HTML text.  This can be used, for example, to write
emails in markdown in Vim and then paste them into Outlook as formatted text.

The plugin currently only supports Windows, although it wouldn't be too hard
to port `HtmlClipboard.py` to support other operating systems and I'd welcome
pull requests.  I only wrote this to allow me to write Outlook emails in
Vim (for most other use I use one of two Chrome plugins - [Markdown Here] or
[Marksy]).

Note that this uses the `HtmlClipboard` python class written by Phillip Piper
and published on [activestate.com].  I used the version posted [here as a
github gist][gistversion]: I only added the vim code.

## Requirements

1. [Vim] >= 8.0.254 (this plugin uses `:pyx` commands to interact with python).
2. Vim must be compiled with working python support.
3. [Python] compatible with Vim.  I've only tested this with python 3.6 at
   present, although it should work with any python 2.7+.
4. Python module [pywin32].
5. A markdown-to-html (and vice-versa) conversion tool.  I use [pandoc].
6. Optional: Python modules [cssutils] and [lxml].  With these modules installed,
   the CSS styling will be more robust.

I have tested this with 64-bit [Anaconda Python] 3.6.1 (which comes with
[pywin32] as standard), 64-bit [Vim] 8.0.776 from [tuxproject.de] and [pandoc]
1.19.2.1.  It was written in about half an hour so may well have a lot of bugs!

## Usage

1. Write markdown in Vim
2. `:CopyToClipboardAsHtml`
3. Paste into Outlook (or whatever)

Optionally also:

1. Write rich text in Outlook (or whatever)
2. Copy to clipboard
3. `:PasteFromClipboardAsMarkdown`

[Vim]: https://www.vim.org
[Python]: https://www.python.org
[pywin32]: http://sf.net/projects/pywin32
[Anaconda Python]: https://www.anaconda.com/download/
[pandoc]: https://pandoc.org
[tuxproject.de]: https://tuxproject.de/projects/vim/
[Marksy]: https://chrome.google.com/webstore/detail/marksy/glncdocnokppgopgpblpeohhhcjggbnl
[Markdown Here]: http://markdown-here.com/
[activestate.com]: http://code.activestate.com/recipes/474121/
[gistversion]: https://gist.githubusercontent.com/Erreinion/6691093/raw/b2e91a7abf92ac08dce6da9060c99c627c993472/HTMLClipboard.py
[cssutils]: http://cthedot.de/cssutils/
[lxml]: http://lxml.de
